; **************************************************************************
; Catgorie : TEMPLATE KEYGEN 1 pour Forum Keygenning FFF.
; Type      : NOM/SERIAL
; Asm       : MASM 8
; Auteur    : LISE_GRIM / KNOW[l]EDGE & PRESAGE / FFF
; **************************************************************************

.486p
.model flat, stdcall
option casemap :none

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                             IMPORTS, DEF
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

include		\masm32\include\windows.inc
include		\masm32\include\user32.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\comctl32.inc
include		\masm32\include\comdlg32.inc

includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\comctl32.lib
includelib	\masm32\lib\comdlg32.lib

DlgKgProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                              CONSTANTS
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const 

IDD_DIALOGBOX		equ	101
IDI_ICON		equ	102
IDB_BITMAP		equ	103
IDC_GENERER		equ	1001
IDC_EXIT		equ	1002
IDC_NOMBOX		equ	1003
IDC_SERIALBOX		equ	1004
IDC_STATIC		equ	-1

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                                 DATA
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data

NomLong		db "Moins de 27 lettres :)",0
NomVide		db "Pas de nom !",0

aKsdf234897544u db 'KSDF234897544URTFBBMNZXCSDKA',0
             
; Remarques :
; 
; NOM = BUF_6BF268
; SERIAL = BUF_6BF2CC

BUF_6BF258      db 0,0,0,0            
BUF_6BF25C      db 0,0,0,0             
BUF_6BF260      db 0,0,0,0             
BUF_6BF264      db 0,0,0              
BUF_6BF267      db 1                   
BUF_6BF268      db 0,0,0,0,0,0,0,0,0,0 
                db 0,0,0,0,0,0,0,0,0,0
                db 0,0,0,0,0
BUF_6BF281      db 0,0,0,0,0,0,0,0,0,0 
                db 0,0,0,0,0,0,0,0,0,0
                db 0,0,0,0,0,0,0,0,0,0
                db 0,0,0,0,0,0,0,0,0,0
                db 0,0,0,0,0,0,0,0,0,0
                db 0,0,0,0,0,0,0,0,0,0
                db 0,0,0,0,0,0,0,0,0,0
                db 0,0,0,0,0
BUF_6BF2CC      db 40 dup (0) 
  
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                                 DATA?
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
 
hInstance	dd ?
NB_NOM		dd ?

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                                 CODE
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code 

start:
	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	invoke	DialogBoxParam, hInstance, IDD_DIALOGBOX, NULL, offset DlgKgProc, 0              
	invoke	ExitProcess, NULL

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                             MAIN DIALOG
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DlgKgProc	PROC	hWnd	:DWORD,
			uMsg	:DWORD,
			wParam	:DWORD,
			lParam	:DWORD

	mov	eax,uMsg    

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.if eax == WM_CLOSE
		invoke	EndDialog, hWnd, NULL

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_LBUTTONDOWN
		mov	eax, lParam
		invoke	PostMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, eax

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_INITDIALOG
		xor	eax, eax
		invoke	LoadIcon,hInstance,IDI_ICON
		invoke	SendMessage,hWnd,WM_SETICON,ICON_SMALL,EAX
	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_COMMAND
		mov	eax,wParam
		mov	edx,wParam
		shr	edx,16
		; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.if ax == IDC_GENERER
			push	33				; nombre de caractres rcuprs
			push	offset BUF_6BF268		; adresse o sera stock le nom
			push	IDC_NOMBOX			; Edit Box du nom
			push	hWnd				; Handle de la fentre
			call	GetDlgItemTextA			; fonction rcupre le nom
			mov	dword ptr [NB_NOM], eax		; rcupre le nombre de lettres

			test	eax, eax			; pas de lettres = pas de serial
			jz	Nom_vide

			cmp	eax, 28				; plus de 30 lettres = pas de serial
			jg	Nom_long

			call	Keygen
			invoke	SetDlgItemText, hWnd, IDC_SERIALBOX, offset BUF_6BF2CC
			jmp	Fin_Generer

			;----------- PAS DE NOM --------------
			Nom_vide:
			invoke	SetDlgItemText, hWnd, IDC_SERIALBOX, offset NomVide
			jmp	Fin_Generer

			;----------- NOM TROP LONG -----------------
			Nom_long:
			invoke	SetDlgItemText, hWnd, IDC_SERIALBOX, offset NomLong

			Fin_Generer:

		; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.elseif ax == IDC_EXIT
			invoke	EndDialog, hWnd, eax
		.endif
	.else
		mov	eax, FALSE
		ret
	.endif

	mov	eax,TRUE
	ret

DlgKgProc	ENDP

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;				KEYGEN ROUTINE
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Keygen		PROC
		pushad
                        lea     ecx, [BUF_6BF268]
                        push    ecx
                        
                        call    ds:CharUpperA
                        mov     al, [BUF_6BF268]
                        lea     esi, [BUF_6BF268]
                        test    al, al
                        lea     edi, [BUF_6BF268]
                        jz      short loc_43192F
            
            loc_43190D: 
                        movsx   edx, byte ptr [esi]
                        push    edx 
                        push    offset aKsdf234897544u 
                        call    _strchr
                        add     esp, 8
                        test    eax, eax
                        jz      short loc_431927
                        mov     al, [esi]
                        mov     [edi], al
                        inc     edi
            
            loc_431927: 
                        mov     al, [esi+1]
                        inc     esi
                        test    al, al
                        jnz     short loc_43190D
            
            loc_43192F: 
                        mov     byte ptr [edi], 0
                        lea     edi, [BUF_6BF268]
                        or      ecx, 0FFFFFFFFh
                        xor     eax, eax
                        repne   scasb
                        not     ecx
                        dec     ecx
                        cmp     ecx, 18h
                        jge     short loc_43195B
                        mov     eax, ecx
            
            loc_431947: 
                        mov     edx, eax
                        sub     edx, ecx
                        inc     eax
                        cmp     eax, 18h
                        mov     dl, byte ptr aKsdf234897544u[edx]
                        mov     [BUF_6BF267 + eax], dl
                        jl      short loc_431947
            
            loc_43195B: 
                        mov     edi, offset aKsdf234897544u 
                        or      ecx, 0FFFFFFFFh
                        xor     eax, eax
                        xor     esi, esi
                        repne   scasb
                        mov     eax, 1
                        xor     ebx, ebx
                        sub     eax, offset aKsdf234897544u 
                        mov     [BUF_6BF281], 0
                        not     ecx
                        mov     dword ptr [BUF_6BF260], eax
                        mov     eax, offset aKsdf234897544u 
                        dec     ecx
                        dec     eax
                        mov     dword ptr [BUF_6BF25C], eax
                        lea     eax, [BUF_6BF268]
                        dec     eax
                        mov     [BUF_6BF2CC], 0
                        mov     dword ptr [BUF_6BF258], ecx
                        lea     ebp, [BUF_6BF2CC]
                        mov     dword ptr [BUF_6BF264], eax
                        jmp     short loc_4319AD
            
            loc_4319A9: 
                        mov     eax, dword ptr [BUF_6BF264]
            
            loc_4319AD: 
                        movsx   eax, byte ptr [eax+ebx+1]
                        lea     edi, [ebx+1]
                        push    eax ; int
                        push    offset aKsdf234897544u 
                        call    _strchr
                        mov     edx, dword ptr [BUF_6BF260]
                        mov     ecx, eax
                        add     ecx, edx
                        add     esp, 8
                        lea     eax, [ecx-1]
                        imul    eax, ecx
                        add     eax, esi
                        mov     ecx, dword ptr [BUF_6BF25C]
                        cdq
                        idiv    dword ptr [BUF_6BF258] ; attention  ne pas oublier le DWORD
                        mov     eax, edi
                        inc     edx
                        inc     ebp
                        mov     esi, edx
                        mov     dl, [ecx+esi]
                        mov     ecx, 6
                        mov     [ebp-1], dl
                        cdq
                        idiv    ecx
                        test    edx, edx
                        jnz     short loc_4319FE
                        cmp     ebx, 17h
                        jge     short loc_4319FE
                        mov     byte ptr [ebp+0], 2Dh
                        inc     ebp
            
            loc_4319FE: 
                        mov     ebx, edi
                        cmp     ebx, 18h
                        jl      short loc_4319A9
                        lea     esi, [BUF_6BF2CC]
 		popad
		ret

Keygen		ENDP
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            loc_0_43F5B0:                    ; c'est le morceau de code mal
                        lea     eax, [edx-1] ; plac  la compilation pour
                        pop     ebx          ; _strchr
                        retn

_strchr proc near 
            
            
                        arg_0 = dword ptr 4
                        arg_4 = byte ptr 8
            
                        xor eax, eax
                        mov al, [esp+arg_4]
            
            ___from_strstr_to_strchr:
                        push ebx
                        mov ebx, eax
                        shl eax, 8
                        mov edx, [esp+4+arg_0]
                        test edx, 3
                        jz short loc_0_43F5EB
            
            loc_0_43F5D8: 
                        mov cl, [edx]
                        inc edx
                        cmp cl, bl
                        jz short loc_0_43F5B0
                        test cl, cl
                        jz short loc_0_43F634
                        test edx, 3
                        jnz short loc_0_43F5D8
            
            loc_0_43F5EB: 
                        or ebx, eax
                        push edi
                        mov eax, ebx
                        shl ebx, 10h
                        push esi
                        or ebx, eax
            
            loc_0_43F5F6: 
                        mov ecx, [edx]
                        mov edi, 7EFEFEFFh
                        mov eax, ecx
                        mov esi, edi
                        xor ecx, ebx
                        add esi, eax
                        add edi, ecx
                        xor ecx, 0FFFFFFFFh
                        xor eax, 0FFFFFFFFh
                        xor ecx, edi
                        xor eax, esi
                        add edx, 4
                        and ecx, 81010100h
                        jnz short loc_0_43F638
                        and eax, 81010100h
                        jz short loc_0_43F5F6
                        and eax, 1010100h
                        jnz short loc_0_43F632
                        and esi, 80000000h
                        jnz short loc_0_43F5F6
            
            loc_0_43F632: 
                        pop esi
                        pop edi
            
            loc_0_43F634: 
                        pop ebx
                        xor eax, eax
                        retn
            
            loc_0_43F638: 
                        mov eax, [edx-4]
                        cmp al, bl
                        jz short loc_0_43F675
                        test al, al
                        jz short loc_0_43F632
                        cmp ah, bl
                        jz short loc_0_43F66E
                        test ah, ah
                        jz short loc_0_43F632
                        shr eax, 10h
                        cmp al, bl
                        jz short loc_0_43F667
                        test al, al
                        jz short loc_0_43F632
                        cmp ah, bl
                        jz short loc_0_43F660
                        test ah, ah
                        jz short loc_0_43F632
                        jmp short loc_0_43F5F6
            
            loc_0_43F660: 
                        pop esi
                        pop edi
                        lea eax, [edx-1]
                        pop ebx
                        retn
            
            loc_0_43F667:
                        lea eax, [edx-2]
                        pop esi
                        pop edi
                        pop ebx
                        retn
            
            loc_0_43F66E: 
                        lea eax, [edx-3]
                        pop esi
                        pop edi
                        pop ebx
                        retn
            
            loc_0_43F675: 
                        lea eax, [edx-4]
                        pop esi
                        pop edi
                        pop ebx
                        retn
_strchr endp
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
END	start
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
